package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.AccountAuthOperation;
import io.accumulatenetwork.sdk.protocol.TransactionBody;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: TransactionType
// UnionValue: UpdateAccountAuth

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("UpdateAccountAuth")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class UpdateAccountAuth implements TransactionBody {
	public final TransactionType type = TransactionType.UPDATE_ACCOUNT_AUTH;
	private AccountAuthOperation[] operations;

    //
	public AccountAuthOperation[] getOperations() {
	    return operations;
	}
	public void setOperations(final AccountAuthOperation[] value) {
	    this.operations = value;
	}

	public UpdateAccountAuth operations(final AccountAuthOperation[] value) {
	    setOperations(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.operations == null)) {
            marshaller.writeValue(2, operations);
        }
        return marshaller.array();
    }
}
